#include <stdlib.h>
#include <iostream.h>
#include "modular.hh"

int isprime(const unsigned p)
{
  if (p < 32)
    return (0xa08a28acUL >> p) & 1;
  if ((0x1f75d77dUL>>(p%30)) & 1)
    return 0;
  unsigned k, sq;
  for (k=7, sq=12; sq <= p/4; sq += (k+=2)-1)
    if (p%k == 0)
      return 0;
  return 1;
}
template <const unsigned *modul>
int findroot(modular<modul> &root, const unsigned n)
{
  const unsigned m = *modul;
  const unsigned negone = m-1;

  if (n < 2 || (n&n-1) || m%n != 1 || !isprime(m))
    return 0;
  if (n/2 < negone/(n/2))
  {
    for (modular<modul> r=2;; ++r)
    {
      if ((r^(negone/2)) == negone)
        break;
    }
    r ^= (negone/n);
    unsigned minimum = r;
    modular<modul> rsquared = r*r;
    for (unsigned i=1; i<n/2; ++i)
    {
      r *= rsquared;
      if (r < minimum)
        minimum = r;
    }
    root = minimum;
  }
  else
  {
    for (modular<modul> r=1;; ++r)
    {
      if ((r^(n/2)) == negone)
        {
          root = r;
          break;
        }
    }

  }
  return 1;
}

unsigned modul;
typedef modular<&modul> vmodular;

main(int ac, char **av)
{
  unsigned n;
  unsigned k;
  unsigned range;
  int dir;
  {
    if (ac < 4
        || (n = atoi(av[3])) < 2
        || (n&(n-1)) != 0)
      {
        cerr << "Usage: bases START END DEGREE [COUNT]\n";
        return 2;
      }
    k = atoi(av[1]);
    unsigned l = atoi(av[2]);
    dir = k > l ? -1 : 1;
    range = (l-k) * dir;
    unsigned dist = (-dir*(k-1))&(n-1);
    if (dist > range)
      return 1;
    k += dir*dist;
    range -= dist;
  }
  int count = ac > 4 ? atoi(av[4]) : 1;
  if (count <= 0)
    return 0;
  for (;;) {
    modul = k;
    vmodular root;
    if (findroot(root, n)) {
      cout << k << ' ' << unsigned(root) << '\n';
      if (--count <= 0)
        return 0;
    }
    if (n > range)
      return 1;
    k += dir * n;
    range -= n;
  }
}
