template <class T> void fft(T arr[], const T roots[], const unsigned n)
{
  for (unsigned offs=n; offs>1; offs/=2)
    {
      for (unsigned i=0, j=offs/2; j<offs; i++, j++)
      {
        T tmp=arr[i];
        arr[i] += arr[j];
        arr[j] = tmp-arr[j];
      }
      for (const T *pp = roots; i=j, (j+=offs/2)<n; )
      {
        T prd = *++pp;
        for (unsigned l=j; i<l; ++i, ++j)
          {
            T tmp = arr[j] * prd;
            arr[j] = arr[i] - tmp;
            arr[i] += tmp;
          }
      }

    }
}

template <class T> void ifft(T arr[], const T roots[], const unsigned n)
{
  for (unsigned offs=2; offs<=n; offs*=2)
    {
      for (unsigned i=0, j=offs/2; j<offs; i++, j++)
      {
        T tmp=arr[i];
        arr[i] += arr[j];
        arr[j] = tmp-arr[j];
      }
      for (const T *pp = roots+n/2; i=j, (j+=offs/2)<n; )
      {
        T prd = *++pp;
        for (unsigned l=j; i<l; ++i, ++j)
          {
            T tmp = arr[j];
            arr[j] = prd*(arr[i] - tmp);
            arr[i] += tmp;
          }
      }

    }
}
template <class T>
void rootcalc(const unsigned n, T roots[], const T proot)
{
  T pow = 1;
  roots[0] = pow;
  roots[n/2] = -pow;
  for (unsigned rev=n/4, negrev=n/2-1, i=1; i<n/2; ++i)
    {
      pow *= proot;
      roots[rev] = pow;
      roots[negrev + n/2] = -pow;
      rev ^= n/2-n/(4*((i+1)&~i));
      negrev ^= n/2-n/(4*(i&~(i-1)));

    }
}
