#include "modular.hh"
#include "fft.hh"
#include <stdlib.h>
#include <iostream.h>
#include <string.h>

extern const unsigned modulus=4294962689U;
typedef modular<&modulus> modtype;
modtype root=27080629U;
const unsigned maxsize = 256;

main(int ac, char **av)
{
  modtype roots[maxsize];
  rootcalc(maxsize, roots, root);

  int scale;
  unsigned overlap = ac-3;
  if (ac < 4 || ac >= maxsize || (scale = atoi(av[1])) == 0) {
    cerr << "Usage: fir scale val1 val2 ...\n";
    exit(1);
  }
  modtype fold[maxsize];
  modtype revers = inverse(modtype(maxsize));
  for (unsigned i=0; i<=overlap; ++i)
    fold[i] = modtype(atoi(av[i+2]))*revers;
  memset(&fold[i], 0, sizeof(*fold)*(maxsize-i));
  fft(fold, roots, maxsize);

  unsigned rest = 0;
  modtype arr[maxsize], save[maxsize];
  memset(&arr[0], 0, sizeof(*arr)*overlap);

  for (;;) {
    if (rest) {
      memset(&arr[overlap], 0, sizeof(*arr)*(maxsize-overlap));
    } else {
      for (i=overlap; i<maxsize; ++i) {
        int in;
        if (!(cin >> in)) {
          memset(&arr[i], 0, sizeof(*arr)*(maxsize-i));
          rest = i;
          break;
        }
        arr[i] = in;
      }
    }

    memcpy(save, arr+maxsize-overlap, sizeof(*arr)*overlap);
    fft(arr, roots, maxsize);
    for (i=0;i<maxsize; ++i)
      arr[i] *= fold[i];
    ifft(arr, roots, maxsize);
    if (rest) {
      if (rest <= maxsize-overlap) {
        for (i=overlap; rest > 0; ++i, --rest)
          cout << int(arr[i])/scale << '\n';
        break;
      }
      rest -= maxsize - overlap;
    }
    for (i=overlap; i<maxsize; ++i)
       cout << int(arr[i])/scale << '\n';

    memcpy(arr, save, sizeof(*arr)*overlap);
  }
  return 0;

}


