template <const unsigned *modul>
class modular
{
  unsigned value;
public:
  inline modular() { }

  inline modular(unsigned u)
  {
    value = u;
  }
  inline modular(int i)
  {
    value = i<0 ? (*modul) - (-i)%(*modul) : i;
  }
  inline modular(const modular<modul> &v)
  {
    value = v.value;
  }
  inline
  operator unsigned() const {
    return value%(*modul);
  }
  inline
  operator int() const {
    return unsigned(*this + *modul/2) - *modul/2;
  }
  inline modular<modul> &
  operator ++()
  {
    if (++value == 0)
      value -= *modul;
    return *this;
  }

  inline modular<modul>
  operator ++(int)
  {
    unsigned old(value);
    ++*this;
    return old;
  }

  inline modular<modul>&
  operator --()
  {
    if (value-- == 0)
      value += *modul;
    return *this;
  }

  inline modular<modul>
  operator --(int)
  {
    unsigned old(value);    
    --*this;
    return old;
  }
  inline modular<modul>&
  operator *=(const modular<modul> &b)
  {
    asm("mull %2;divl %3"
        : "=&d" (value)
        : "%&a" (value), "mr0" (b.value) , "mr" (*modul)
        : "cc");
    return *this;
  }

  inline friend modular<modul>
  operator *(const modular<modul> &a, const modular<modul> &b)
  {
    unsigned r;
    asm("mull %2;divl %3"
        : "=&d" (r)
        : "%&a" (a.value), "mr0" (b.value) , "mr" (*modul)
        : "cc");
    return r;
  }
  inline modular<modul>&
  operator +=(const modular<modul>&b)
  {
    asm("addl %2,%0;jnc 1f;0:subl %3,%0;jnc 0b;1:"
        : "=&r" (value)
        : "%0" (value), "g" (b.value), "ri" (*modul)
        : "cc");
    return *this;
  }

  inline friend modular<modul>
  operator +(const modular<modul>&a, const modular<modul>&b)
  {
    unsigned r;
    asm("addl %2,%0;jnc 1f;0:subl %3,%0;jnc 0b;1:"
        : "=&r" (r)
        : "%0" (a.value), "g" (b.value), "ri" (*modul)
        : "cc");
    return r;
  }
  inline modular<modul>&
  operator -=(const modular<modul>&b)
  {
    asm("subl %2,%0;jnc 1f;0:addl %3,%0;jnc 0b;1:"
        : "=&r" (value)
        : "0" (value), "g" (b.value), "ri" (*modul)
        : "cc");
    return *this;
  }

  inline friend modular<modul>
  operator -(const modular<modul>&a)
  {
    unsigned r;
    asm("negl %0;jnc 1f;0:addl %2,%0;jnc 0b;1:"
        : "=&r" (r)
        : "0" (a.value), "ri" (*modul)
        : "cc");
    return r;
  }

  inline friend modular<modul>
  operator -(const modular<modul>&a, const modular<modul> &b)
  {
    unsigned r;
    asm("subl %2,%0;jnc 1f;0:addl %3,%0;jnc 0b;1:"
        : "=&r" (r)
        : "0" (a.value), "g" (b.value), "ri" (*modul)
        : "cc");
    return r;
  }
  inline friend modular<modul>
  inverse(const modular<modul>& b)
  {
    unsigned u1 = 0, u2 = *modul, v1=1, v2=b;
    
    for (;;) {
      if (v2 == 0)
        return *modul+u1;
      u1 -= (u2/v2)*v1;
      u2 %= v2;
      if (u2 == 0)
        return v1;
      v1 -= (v2/u2)*u1;
      v2 %= u2;
    }
  }
  inline friend modular<modul>
  operator /(const modular<modul> &a, const modular<modul> &b)
  {
    return a*inverse(b);
  }
  inline friend modular<modul>
  operator ^(modular<modul> b, unsigned e)
  {
    modular<modul> r = (e&1) ? b : modular<modul>(1);

    for (;;) {
      if ((e /= 2) == 0)
        return r;
      b *= b;
      if (e&1)
        r *= b;
    }
  }

  inline modular<modul> &
  operator ^=(unsigned e)
  {
    return (*this = *this^e);
  }
};
